extern struct strTime
{
  unsigned char Year;
  unsigned char Month;
  unsigned char Day;
  unsigned char Week;
  unsigned char Hour;
  unsigned char Minute;
  unsigned char Second;
} Now;

extern void           InitDS1302(void);
extern void           DS1302_ByteWrite( char Datas);
extern unsigned char  DS1302_ByteRead(void);
extern void           DS1302_DataWrite(unsigned char Command, unsigned char Datas);
extern unsigned char  DS1302_DataRead(char Command);
extern void           DS1302_WriteByteRAM(unsigned char Address, unsigned char Data);
extern void           DS1302_WriteIntRAM(unsigned char Address, unsigned int Data);
extern unsigned char  DS1302_ReadByteRAM(unsigned char Address);
extern unsigned int   DS1302_ReadIntRAM(unsigned char Address);

extern void           DS1302_SetTime(unsigned char Year, unsigned char Month, unsigned char Day, 
                      unsigned char Week, unsigned char Hour, unsigned char Minute, unsigned char Second);
extern void           DS1302_GetTime(void);
extern void DS1302_SetSecond(unsigned char Second);
extern void DS1302_SetMinute(unsigned char Minute);
extern void DS1302_SetHour(unsigned char Hour);
extern void DS1302_SetWeek(unsigned char Week);
extern void DS1302_SetDay(unsigned char Day);
extern void DS1302_SetMonth(unsigned char Month);
extern void DS1302_SetYear(unsigned char Year);

