#include <msp430x14x.h>
#include "Key.h"
#include "Number_Setting.h"
#include "Display.h"
#include "Timer_A.h"
#include  "Pot_To_Pot.h"

unsigned int x_val,y_val;
unsigned char starting;
unsigned char D_FLAG_X;  
unsigned char D_FLAG_Y;
void Setting(void)
 {    
   unsigned char Tmp_Key; 
Lable_SubM_CalibSetting_1:  
   while(1)
    {  D_FLAG_X=0;
       D_FLAG_Y=1;
       Display_Number(x_val, 72, 16, 2, M_8X16, D_FLAG_X); 
       Display_Number(y_val, 96, 16, 3, M_8X16, D_FLAG_Y );
       Tmp_Key = Key_Scan();
       x_val = Key_SetValue_pointunit(Tmp_Key, x_val, 0, 80, 1);
       if (Tmp_Key == KEY_SEL) goto Lable_SubM_CalibSetting_2;
       if (Tmp_Key == KEY_ENT) goto Lable_SubM_CalibSetting_3;
    }
   
Lable_SubM_CalibSetting_2:
    while(1)
    {  D_FLAG_X=1;
       D_FLAG_Y=0;
       Display_Number(x_val, 72, 16, 2, M_8X16, D_FLAG_X); 
       Display_Number(y_val, 96, 16, 3, M_8X16, D_FLAG_Y );
       Tmp_Key = Key_Scan();
       y_val = Key_SetValue_pointunit(Tmp_Key, y_val, 0,100, 1);
       if (Tmp_Key == KEY_SEL) goto Lable_SubM_CalibSetting_1;
       if (Tmp_Key == KEY_ENT) goto Lable_SubM_CalibSetting_3;
    }
Lable_SubM_CalibSetting_3:            
       Display_Number(x_val, 72, 16, 2, M_8X16, 1); 
       Display_Number(y_val, 96, 16, 3, M_8X16, 1 );
       starting=1;
       //return()
     
 }


//ǣx0,y0,ֶõĵǣx1,y1,΢Сõĵ
void Motor_Run_Next_point(float x0,float y0,float x1,float y1)
{ 
  float Spot_a_midify,Spot_b_midify;//
  float k;//б
  long int dot_num;//
  unsigned int i=0;
  float last_x0,last_y0;//
  float next_x1,next_y1;//յ
  float next_x,next_y;// ;
  
  x_last=x0;
  y_last=y0;            
  mtor_a_leth_last=(x_last+LEN_A_X)*(x_last+LEN_A_X)+(LEN_A_Y-y_last)*(LEN_A_Y-y_last);//һmotor_aĳ
  mtor_b_leth_last=(LEN_B_X -x_last)*(LEN_B_X -x_last)+(LEN_B_Y-y_last)*(LEN_B_Y-y_last);
  mtor_a_leth_last=Quick_Sqrt(mtor_a_leth_last);//ʼ߳
  mtor_b_leth_last=Quick_Sqrt(mtor_b_leth_last);
  
  //ֶõֵֹйֵı
  last_x0=x0;
  last_y0=y0;
  next_x1=x1;
  next_y1=y1;
  
  if((last_x0==next_x1)&&(last_y0==next_y1))
    return;
  if(last_x0==next_x1)
  {
   dot_num=(int)(((next_y1-last_y0)/0.4)+0.5);
   //dot_num=(int)((next_y1-last_y0)*5);
   //k=(next_y1-last_y0)/(next_x1-last_x0);
   while(i<=dot_num-1)
   { 
     i++;
     next_x=x0;
     next_y=last_y0+0.4;
     
     //˶һ΢С
     Point_To_Point(Spot_a_midify+next_x,Spot_b_midify+next_y);
    // DelayNms(100);
     
     //ˢʾ˶    
     Display_Decimal(100*next_x,16, 32, 2, 2, M_8X16, D_NOR); 
     Display_Decimal(100*next_y,64, 32, 3, 2, M_8X16, D_NOR);
     
     //ˢ¼ʱ
     Display_Number(Seconds, 56, 48, 3, M_8X16, D_NOR);
     
     last_y0=next_y;
        
     }
    }
  
  
  if(last_y0==next_y1)
  {
   dot_num=(int)(((next_x1-last_x0)/0.3)+0.5);
   //dot_num=(int)((next_y1-last_y0)*5);
   //k=(next_y1-last_y0)/(next_x1-last_x0);
   while(i<=dot_num-1)
   { 
     i++;
     next_y=y0;
     next_x=last_x0+0.3;
     
     //˶һ΢С
     Point_To_Point(Spot_a_midify+next_x,Spot_b_midify+next_y);
    // DelayNms(100);
     
     //ˢʾ˶    
     Display_Decimal(100*next_x,16, 32, 2, 2, M_8X16, D_NOR); 
     Display_Decimal(100*next_y,64, 32, 3, 2, M_8X16, D_NOR);
     
     //ˢ¼ʱ
     Display_Number(Seconds, 56, 48, 3, M_8X16, D_NOR);
     
     last_x0=next_x;
        
     }
    }
   else
    {
       k=(next_y1-last_y0)/(next_x1-last_x0);
       if(k>1)   //Xȡ      
       { 
         dot_num=(int)((next_x1-last_x0)/0.3+0.5);
        // dot_num=(int)((next_x1-last_x0)/(ONE_STEP_LETH)+0.5);
         while(i<=dot_num-1)
         { 
           i++;         
           next_x=last_x0+0.3;
           next_y=k*(next_x-x0)+y0;
           
           //˶һ΢С
           Point_To_Point(Spot_a_midify+next_x,Spot_b_midify+next_y);
           // DelayNms(100);
           //ˢʾ˶    
           Display_Decimal(100*next_x,16, 32, 2, 2, M_8X16, D_NOR); 
           Display_Decimal(100*next_y,64, 32, 3, 2, M_8X16, D_NOR);
     
           //ˢ¼ʱ
           Display_Number(Seconds, 56, 48, 3, M_8X16, D_NOR);
     
           last_x0=next_x;           
          }
        }
         if(k<=1)
           {
             dot_num=(int)((next_y1-last_y0)/0.3+0.5);
             while(i<=dot_num-1)
             { i++;
               next_y=last_y0+0.3;
               next_x=(x0+(next_y-y0)/k);
               //˶һ΢С
               Point_To_Point(Spot_a_midify+next_x,Spot_b_midify+next_y);
               //DelayNms(100);
               //ˢʾ˶    
               Display_Decimal(100*next_x,16, 32, 2, 2, M_8X16, D_NOR); 
               Display_Decimal(100*next_y,64, 32, 3, 2, M_8X16, D_NOR);
               
              //ˢ¼ʱ
               Display_Number(Seconds, 56, 48, 3, M_8X16, D_NOR);
     
               last_y0=next_y;   
               
             }
                           
           }
                                            
       }
              
  }

void Back_Motor_Run_Next_point(float x0,float y0,float x1,float y1)
{ 
  float Spot_a_midify,Spot_b_midify;//
  float k;//б
  unsigned int dot_num;//
  unsigned int i=0;
  float last_x0,last_y0;//
  float next_x1,next_y1;//յ
  float next_x,next_y;// ;
  
  x_last=x0;
  y_last=y0;            
  mtor_a_leth_last=(x_last+LEN_A_X)*(x_last+LEN_A_X)+(LEN_A_Y-y_last)*(LEN_A_Y-y_last);//һmotor_aĳ
  mtor_b_leth_last=(LEN_B_X -x_last)*(LEN_B_X -x_last)+(LEN_B_Y-y_last)*(LEN_B_Y-y_last);
  mtor_a_leth_last=Quick_Sqrt(mtor_a_leth_last);//ʼ߳
  mtor_b_leth_last=Quick_Sqrt(mtor_b_leth_last);
  
  //ֶõֵֹйֵı
  last_x0=x0;
  last_y0=y0;
  next_x1=x1;
  next_y1=y1;
  
  if(last_x0==next_x1)
  {
   dot_num=(int)(((last_y0-next_y1)/0.4)+0.5);
   while(i<=dot_num-1)
   { 
     i++;
     next_x=x0;
     next_y=last_y0-0.4;     
     Point_To_Point(Spot_a_midify+next_x,Spot_b_midify+next_y);//˶һ΢С
    // DelayNms(100);     
     last_y0=next_y;        
    }
   }
  if(last_y0==next_y1)
  {
   dot_num=(int)(((last_x0-next_x1)/0.3)+0.5);
   while(i<=dot_num-1)
   { 
     i++;
     next_y=y0;
     next_x=last_x0-0.3;    
     Point_To_Point(Spot_a_midify+next_x,Spot_b_midify+next_y); //˶һ΢С
     // DelayNms(100);          
     last_x0=next_x;        
     }
    }
   else
    {
       k=(next_y1-last_y0)/(next_x1-last_x0);
       if(k>1)   //Xȡ      
       { 
         dot_num=(int)((last_x0-next_x1)/0.3+0.5);
         while(i<=dot_num-1)
         { 
           i++;         
           next_x=last_x0-0.3;
           next_y=k*(next_x-x0)+y0;           
           //˶һ΢С
           Point_To_Point(Spot_a_midify+next_x,Spot_b_midify+next_y);
           // DelayNms(100);
           last_x0=next_x;           
          }
        }
         if(k<=1)
           {
             dot_num=(int)((last_y0-next_y1)/0.3+0.5);
             while(i<=dot_num-1)
             { 
               next_y=last_y0-0.3;
               next_x=(x0+(next_y-y0)/k);
               //˶һ΢С
               Point_To_Point(Spot_a_midify+next_x,Spot_b_midify+next_y);
               //DelayNms(100);     
               last_y0=next_y;   
               i++;
             }
                           
           }
                                            
       }
              
  }


















