#include <msp430x14x.h>
#include "Math.h"
#include  "Pot_To_Pot.h"

unsigned int  motor_a=0;       
unsigned int  motor_a_pulse;   //΢СҪʱĸ
unsigned int  motor_b=0;
unsigned int  motor_b_pulse;    //΢СҪʱĸ

float x_last,y_last;//㣬ǰ
float mtor_a_leth_last,mtor_b_leth_last; //ǰߵĳ

unsigned char motor_a_busy,motor_b_busy;
unsigned char interrupt_flg_a,interrupt_flg_b;

void DelayNms(unsigned int Nms)
{
  unsigned int i;
  for(; Nms>0; Nms--)
  {
    for(i=0; i<129; i++) _NOP();    
  }
}
/*
#pragma vector = TIMERB0_VECTOR
__interrupt void TB_CCR0(void)
  {
             if(motor_b==motor_b_pulse+1)  
             { TBCCTL3 &=~CCIE;
               MTOR_B_CLK_OFF;
                motor_b=0;
                motor_b_pulse=0;
                interrupt_flg_b=1;
             }  

             if(motor_a==motor_a_pulse+1)  
             {         
               TBCCTL6 &=~CCIE;
               MTOR_A_CLK_OFF;
               motor_a=0;
               motor_a_pulse=0;
               interrupt_flg_a=1;
             } 


  }

*/

// TBȽϲжϷ
#pragma vector = TIMERB1_VECTOR
__interrupt void TB_Pulse(void)
{   
   switch(TBIV)
  {
    case 6:  motor_b++; 
             if(motor_b==motor_b_pulse+1)  
             { TBCCTL3 &=~CCIE;
               MTOR_B_CLK_OFF;
                motor_b=0;
                motor_b_pulse=0;
                interrupt_flg_b=1;
             }    
             break;                          
    case 12: motor_a++; 
             if(motor_a==motor_a_pulse+1)  
             {         
               TBCCTL6 &=~CCIE;
               MTOR_A_CLK_OFF;
               motor_a=0;
               motor_a_pulse=0;
               interrupt_flg_a=1;
             }      
             break;     
    default: break;
    
  }  
     
}

//TBҪṩMotor_RightMotor_Leftĵ㵽΢Сƶ
void TB_Init(void)
 {
  TBCTL    = TBSSEL_1 + TBCLR + ID_0 + MC_1; //ѡACLK,㣬Ƶģʽ
   TBCCTL3 |= OUTMOD_7;
   TBCCTL6 |= OUTMOD_7;
   //TBCCTL3 |= CCIE;   //Motor_B㵽жʹ

   _EINT(); //ж
 }

//ǿĿټ㿪ƽĺ
float Quick_Sqrt( float number )
{
  long int i;
  unsigned char j;
  float x2, y;
  const float threehalfs = 1.5F;
  x2 = number * 0.5F;
  y  = number;
  i  = * ( long * ) &y;         // BITǿи
  i  = 0x5f3759df - ( i >> 1 ); // û
  y  = * ( float * ) &i;
  for(j=0;j<1;j++) 
   {
     y  = y * ( threehalfs - ( x2 * y * y ) ); // 1ε
   }
  return (1/y);
}


//΢С˶
void Point_To_Point(float x_next, float y_next)
{
	float mtor_a_leth_next, mtor_b_leth_next;
	float a_change, b_change;
        TB_Init();
 	mtor_a_leth_next=(x_next+LEN_A_X)*(x_next+LEN_A_X)+(LEN_A_Y-y_next)*(LEN_A_Y-y_next);//һmotor_aĳ
 	mtor_b_leth_next=(LEN_B_X -x_next)*(LEN_B_X -x_next)+(LEN_B_Y-y_next)*(LEN_B_Y-y_next);
  	mtor_a_leth_next=Quick_Sqrt(mtor_a_leth_next);
  	mtor_b_leth_next=Quick_Sqrt(mtor_b_leth_next);
                
 	a_change=mtor_a_leth_next-mtor_a_leth_last;   //0
 	b_change=mtor_b_leth_next-mtor_b_leth_last;
 	mtor_a_leth_last=mtor_a_leth_next;
 	mtor_b_leth_last=mtor_b_leth_next;
 	x_last=x_next;
 	y_last=y_next;
    
    if(a_change>=0)       
      { 
        MTOR_A_RUN_DOWN;    //motor_a
      }
    else 
 	{
         MTOR_A_RUN_UP;
 	 a_change=-a_change;
 	} 		
 	motor_a_pulse=(int)(a_change/ONE_STEP_LETH+0.5);
        
        
        if(motor_a_pulse<=0)        
        { 
          TBCCTL6 &=~CCIE;
          MTOR_A_CLK_OFF;  
        }
        else         
        {  //תһ΢С
         
           MTOR_A_ON ;
           MTOR_A_CLK_ON ;
           TBCCTL6 |= CCIE;  //Motor_A㵽жʹ
           //TBCCTL0 |= CCIE;
          //æ
           do{
           if(interrupt_flg_a==1)      motor_a_busy=0;
           else                        motor_a_busy=1;            
           }
        while(motor_a_busy==1);
          interrupt_flg_a=0;
          
        }
        

    
          
 	if(b_change>=0)
        { 
          MTOR_B_RUN_DOWN;
        }
        else{ 
            MTOR_B_RUN_UP;
            b_change=-b_change;
        }
 	motor_b_pulse=(int)(b_change/ONE_STEP_LETH+0.5);   //ȡ
        
        
        if(motor_b_pulse<=0)
        { TBCCTL3 &= ~CCIE; 
          MTOR_B_CLK_OFF;
        }
        else
        {  //תһ΢С

           MTOR_B_ON ;
           MTOR_B_CLK_ON ;
           TBCCTL3 |= CCIE;  //Motor_B㵽жʹ
           //TBCCTL0 |= CCIE;
           //æ
        do{
           if(interrupt_flg_b==1)      motor_b_busy=0;
           else                        motor_b_busy=1;            
           }
        while(motor_b_busy==1);
          interrupt_flg_b=0;  
           
        }  	
        
            
     
}
