 
//*Modify Date:    еײ㺯ͨ
//                Display_Full()ʵȫ
//                       ΪҺװ, ת(Ӱٶ)

#include "T6963.h"

/* 궨 */
// T6963 ƶ˿ڶ
// ˿
#define PORT_T6963_CTL_OUT              P3OUT
#define PORT_T6963_CTL_IN               P3IN
#define PORT_T6963_CTL_DIR              P3DIR
// Ŷ 
#define PIN_T6963_RD                    BIT5
#define PIN_T6963_WR                    BIT4
#define PIN_T6963_CE                    BIT6
#define PIN_T6963_CD                    BIT7
#define PIN_T6963_RST                   0
// Ŷ
#define PIN_T6963_RD_HIGH               (PORT_T6963_CTL_OUT |=  PIN_T6963_RD)
#define PIN_T6963_RD_LOW                (PORT_T6963_CTL_OUT &= ~PIN_T6963_RD)
#define PIN_T6963_WR_HIGH               (PORT_T6963_CTL_OUT |=  PIN_T6963_WR)
#define PIN_T6963_WR_LOW                (PORT_T6963_CTL_OUT &= ~PIN_T6963_WR)
#define PIN_T6963_CD_HIGH               (PORT_T6963_CTL_OUT |=  PIN_T6963_CD)
#define PIN_T6963_CD_LOW                (PORT_T6963_CTL_OUT &= ~PIN_T6963_CD)
#define PIN_T6963_CE_HIGH               (PORT_T6963_CTL_OUT |=  PIN_T6963_CE)
#define PIN_T6963_CE_LOW                (PORT_T6963_CTL_OUT &= ~PIN_T6963_CE)
#define PIN_T6963_RST_HIGH              (PORT_T6963_CTL_OUT |=  PIN_T6963_RST)
#define PIN_T6963_RST_LOW               (PORT_T6963_CTL_OUT &= ~PIN_T6963_RST)
// T6963 ݶ˿ڶ 
// ˿
#define PORT_T6963_DATA_OUT             P5OUT
#define PORT_T6963_DATA_IN              P5IN
#define PORT_T6963_DATA_DIR             P5DIR
// Ŷ
#define PORT_T6963_DATA_DOUT            (PORT_T6963_DATA_DIR = 0xff)
#define PORT_T6963_DATA_DIN             (PORT_T6963_DATA_DIR = 0x00)   
// ʱӳ
#define T6963_DELAY                     (1)


/* ȫֱ ------------------------------------------------------------- */
unsigned char Flg_BusyWrite;              // æ־
unsigned char Flg_BusyAutoWrite;              // æ־

/* ײʱ ------------------------------------------------------------- */
// ӳٳ(΢ӳ)
void T6963_Delay(unsigned int time)
{
  for(; time>0; time--){}
}

/*˵: ײʱĲȻǽ׼, ׼, ȻCEһһ
        עCEͺ(150usԺ)ȡ*/
// Ĵ״̬(Ҫæ)
// RD   L
// WR   H
// CD   H
unsigned char T6963_StatusRead(void)
{
  unsigned char Status;
  // 
  PIN_T6963_RD_LOW;
  PIN_T6963_WR_HIGH;
  PIN_T6963_CD_HIGH;
  // æ
  PIN_T6963_CE_LOW;
  T6963_Delay(T6963_DELAY);
  Status = PORT_T6963_DATA_IN;
  PIN_T6963_CE_HIGH;
  
  return Status;
}

// Һ/дæ
void T6963_BusyWrite(void)
{
  unsigned char Status;
  do
  {
    // ȡ״̬
    Status = T6963_StatusRead();
    // жϱ־
    if ((Status & 0x03) == 0x03) Flg_BusyWrite = 0;   /* !! æ !! */
    else                         Flg_BusyWrite = 1;
  }
  while(Flg_BusyWrite == 1);
}

// Һ/дæ
void T6963_BusyAutoWrite(void)
{
  unsigned char Status;
  do
  {
    // ȡ״̬
    Status = T6963_StatusRead();
    // жϱ־  
    if ((Status & 0x08) == 0x08) Flg_BusyAutoWrite = 0;   /* !! æ !! */
    else                         Flg_BusyAutoWrite = 1;
  }
  while(Flg_BusyAutoWrite == 1);
}


// дݵҺ
// RD   H
// WR   L
// CD   L
void T6963_WriteData(unsigned char Data)
{
  T6963_StatusRead();    // æ
  // 
  PIN_T6963_RD_HIGH;
  PIN_T6963_WR_LOW;      
  PIN_T6963_CD_LOW;
  // ݷ
  PORT_T6963_DATA_DOUT;
  // ׼
  PORT_T6963_DATA_OUT = Data;
  T6963_Delay(T6963_DELAY);
  // д
  PIN_T6963_CE_LOW;
  T6963_Delay(T6963_DELAY);
  PIN_T6963_CE_HIGH;
  // ݷ
  PORT_T6963_DATA_DIN;
}

// дҺ
// RD   H
// WR   L
// CD   H
void T6963_WriteCommand(unsigned char Command)
{
  T6963_StatusRead();    // æ
  // 
  PIN_T6963_RD_HIGH;
  PIN_T6963_WR_LOW;      
  PIN_T6963_CD_HIGH;
  // ݷ
  PORT_T6963_DATA_DOUT;
  // ׼
  PORT_T6963_DATA_OUT = Command;
  T6963_Delay(T6963_DELAY);
  // д
  PIN_T6963_CE_LOW;
  T6963_Delay(T6963_DELAY);
  PIN_T6963_CE_HIGH;
  // ݷ
  PORT_T6963_DATA_DIN;
}

// ݴҺ
// RD   L
// WR   H
// CD   L
unsigned char T6963_ReadData(void)
{
  unsigned char Temp;
  T6963_StatusRead();    // æ
  // 
  PIN_T6963_WR_HIGH;      
  PIN_T6963_RD_LOW;
  PIN_T6963_CD_LOW;
  // 
  PIN_T6963_CE_LOW;
  T6963_Delay(T6963_DELAY);
  Temp = PORT_T6963_DATA_IN;
  PIN_T6963_CE_HIGH;
  return (Temp);
}

/* ܺ ----------------------------------------------------------------- */

/*ע: Reg_ADPһҪʼΪΪ0, ַŻһֱ !!!
        ǳʼΪ(y << 4) + x,  y > 64
        Ҳ˵, ҪReg_ADPʼҺʾĵַ */
unsigned int Reg_ADP = 0xffff;  // LCDģַ, ģLCDڲָ, ָǰʾַ 

/*Ż: T6963_LocateXY()жԵַλŻ, 
        6963ڲDATA_WRITE_INC_ADP, T6963_Locate()ʹøģʽ 
        ģһַReg_ADP6963ڲRAMַ
        Reg_ADP6963, ˵д, ʡȥַλ*/
// λõַõ(x, y)λ
void T6963_LocateXY(unsigned char x, unsigned char y)
{
  unsigned int Tmp_ADP;
  // ַŻ
  Tmp_ADP = (y << 4) + x;
  if (Reg_ADP == Tmp_ADP) return;
  // ģַ
  Reg_ADP = Tmp_ADP;
  // ַ
  T6963_WriteData(Reg_ADP%256);
  T6963_WriteData(Reg_ADP/256);
  T6963_WriteCommand(0x24); // SET_ADDRESS_POINTER õַ

}

// ڵǰλдһֽ(λָ+1)
void T6963_LocateWrite(unsigned char Data)
{
  T6963_WriteData(Data);
  T6963_WriteCommand(0xc0); // DATA_WRITE_INC_ADP дָ++
  Reg_ADP++;
}

// ڵǰλöȡһֽ(λָ+1)
unsigned char T6963_LocateRead(void)
{
  unsigned char Data;
  Data = T6963_ReadData();
  T6963_WriteCommand(0xc1); // DATA_READ_INC_ADP ָ++
  Reg_ADP++;
  return Data;
}

/* ϲ㺯 ----------------------------------------------------------------- */

/*˵: ǹⲿļõ, ɶҺĳò
        T6963_Locate()ָλʾһֽڵ(ȡ)
        T6963_Clear()ʾĻ
        T6963_Init()ʼ430Һģ, ѾҺڲ״̬*/
// ָ(x,y)λдһ
_EXTERN void T6963_Locate(unsigned char x, unsigned char y, unsigned char Data, unsigned Flg_Inv)
{
//  unsigned char Tmp_Data = 0;
//  unsigned char i;
  
  if (Flg_Inv == D_INV) Data = ~Data; // Flg_Inv־ȡ
  
  /* !!! ĳ˰Һװ, ｫx,y괦һ, װθö !!! */
 // x = 15 - x; y = 63 - y; // 任
 // for(i=0; i<8; i++)     // 任
 // {
  //  Tmp_Data <<= 1;
  //  if (Data & 0x01) Tmp_Data |= 0x01;
  //  Data >>= 1;
 // }
 // Data = Tmp_Data;
  
  /* ----------------------------------------------------------------------------- */
  
  T6963_LocateXY(x, y);   // ǰλָ
  T6963_LocateWrite(Data);// д
}

/*Ż: T6963_Clear()Һ1024RAMֽڽд0x00Ĳ
        Բдʽĵʱ*/
// 亯
void T6963_Full(unsigned char FullData)
{
  unsigned int i;
  // ַ
  T6963_WriteData(0);
  T6963_WriteData(0);
  T6963_WriteCommand(0x24); // SET_ADDRESS_POINTER õַ
  // 
  T6963_WriteCommand(0xb0); // SET_DATA_AUTO_WRITE д: 
  for(i=0; i<0x400; i++) 
  {
    T6963_BusyAutoWrite();  // æ
    T6963_WriteData(FullData);  // д
  }
  T6963_WriteCommand(0xb2); // SET_DATA_AUTO_WRITE д: 
}
// Ļ
_EXTERN void T6963_Clear(void)
{
  T6963_Full(0x00);
}

/*ע: ʼҪĲ־ҺĹܳʼ  !!!
        Ҫע
        Set Text Home Addressʱ, дݵ8λ, ȻǸ8λ, ָ0x40
        Set Grapgic Home Addressʱ, ͬ
        Set Text Areaʱ, ʾһֽ, 128^64, һ16ֽ, һ64
        Set Text Areaʱ, Ҫ, м仹Ҫдһ0x00, Ȼдָ0x41
        Set Grapgic Areaʱ, ͬ
        Memory Mode Setʱ, ʹInternal/External CGRAMûʲô(Graphic)
        Display Mode Setʱ, Text, ˸Ͳÿ*/
// ʼ
_EXTERN void T6963_Init(void)
{
  // 
  PORT_T6963_CTL_OUT |= PIN_T6963_RD + PIN_T6963_WR + PIN_T6963_CE + PIN_T6963_CD + PIN_T6963_RST;
  PORT_T6963_CTL_DIR |= PIN_T6963_RD + PIN_T6963_WR + PIN_T6963_CE + PIN_T6963_CD + PIN_T6963_RST;
  PORT_T6963_DATA_DIN;
  
  // ӲλҺ
  PIN_T6963_RST_LOW;
  T6963_Delay(200);
  PIN_T6963_RST_HIGH;
  T6963_Delay(10);
  
  // ܳʼ
  T6963_WriteData(0x00);  T6963_WriteData(0x40);  T6963_WriteCommand(0x40);   // Set Text Home Address = 0x0400
  T6963_WriteData(0x10);  T6963_WriteData(0x00);  T6963_WriteCommand(0x41);   // Set Text Area 20 Columns
  T6963_WriteData(0x00);  T6963_WriteData(0x00);  T6963_WriteCommand(0x42);   // Set Grapgic Home Address = 0x0200
  T6963_WriteData(0x10);  T6963_WriteData(0x00);  T6963_WriteCommand(0x43);   // Set Grapgic Area 20 Columns
  T6963_WriteCommand(0x80);   // OR Mode, Internal CGRAM Mode
  T6963_WriteCommand(0x98);   // Display On, Grapgic On, Text Off
  
  // Ļ
  T6963_Clear();
}



