#include <msp430x14x.h>
#include "Global.h"
#include "Find_Sport.h"
#include "Pot_To_Pot.h"
#include "Display.h"
#include "T6963.h"
#include "Key.h"
#include "Timer_A.h"
#include "Number_Setting.h"


unsigned char SensorData[4];
unsigned char flag,Input;
unsigned char Find_mode;
unsigned char a=0,b=0,c=0,d=0;
float x,y;
unsigned char Find_key_value;
unsigned char Find_dir=1;
unsigned char Find_starting=0;
 void Cacu_Find_Sport(void)
 {   //
     Display_String("****ѭ˶****\n", 0, 0, M_8X16, D_INV);
     
     //
     Display_String("\n", 0, 16, M_8X16, D_NOR);
     Display_String("(\n", 64, 16, M_8X16, D_NOR);
     Display_Number(x_val, 72, 16, 2, M_8X16, D_INV);
     Display_String(",\n", 88, 16, M_8X16, D_NOR);
     Display_Number(y_val, 96, 16, 3, M_8X16, D_INV);
     Display_String(")\n", 120, 16, M_8X16, D_NOR);
    
     //ʵʱʾ켣
     Display_String(" (\n", 0, 32, M_8X16, D_NOR);
     Display_Decimal(100*x,16, 32, 2, 2, M_8X16, D_NOR); 
     Display_String(",\n", 56, 32, M_8X16, D_NOR);
     Display_Decimal(100*y,64, 32, 3, 2, M_8X16, D_NOR);
     Display_String(") \n", 112, 32, M_8X16, D_NOR);
     
     //ʱ
     Display_String("ʱ:\n", 8, 48, M_8X16, D_NOR);
     Display_Number(Seconds, 56, 48, 3, M_8X16, D_NOR);
     Display_String("s\n", 84, 48, M_8X16, D_NOR);   
   
     InitSensor(); //ʼ⴫
     Setting(); //ѭ
     
     //ߵĳ
     x=x_val;
     y=y_val;
     x_last=x;
     y_last=y;  
     mtor_a_leth_last=(x_last+LEN_A_X)*(x_last+LEN_A_X)+(LEN_A_Y-y_last)*(LEN_A_Y-y_last);//һmotor_aĳ
     mtor_b_leth_last=(LEN_B_X -x_last)*(LEN_B_X -x_last)+(LEN_B_Y-y_last)*(LEN_B_Y-y_last);
     mtor_a_leth_last=Quick_Sqrt(mtor_a_leth_last);
     mtor_b_leth_last=Quick_Sqrt(mtor_b_leth_last);
     
     //óʼѭ
     while(Find_dir)
     {
       Find_key_value= Key_Scan();
       switch(Find_key_value)
       {
         case KEY_UUP : flag=up;    Find_dir=0;Find_starting=1;break;               
         case KEY_DWN : flag=down;  Find_dir=0;Find_starting=1;break;               
         case KEY_LFT : flag=left;  Find_dir=0;Find_starting=1;break;              
         case KEY_RGH : flag=right; Find_dir=0;Find_starting=1;break;                   
       }     
     }
     
    if(Find_starting)  TA_IE_ON;//򿪼ʱ
     
  //ʼѭ
  while(Find_mode)
  { 
    //ʵʱɨʾ 
    Display_Decimal(100*x,16, 32, 2, 2, M_8X16, D_NOR); 
    Display_Decimal(100*y,64, 32, 3, 2, M_8X16, D_NOR);    
    //ʵʱɨʾʱʱ
    Display_Number(Seconds, 56, 48, 3, M_8X16, D_NOR);
    
    ReadSensor();//ȡ⴫״̬
    Oren_control(Input);//ѭ
   
  }
 }

//ʱ
void Delay()                        
{
 long int i;
 for(i=0;i<100;i++); //ӳ,Լ700΢
}


//ʼ
void InitSensor()                   
{
  P2DIR |=(BIT4+BIT5+BIT6+BIT7);      //P2.4~7 ֻƴԴŶĬ״̬룩
  P2DIR &=~(BIT0+BIT1+BIT2+BIT3);

}

//Ӵȡǰλ
unsigned char ReadSensor(void)
{
 //4ֽڵ飬ڴ4ֵ     
  unsigned char i,j=0,falg_equel=0;
  unsigned char Sample_Input[COMPARE_NUM];
  
  Loop:
  while(j<COMPARE_NUM)
 {PSEN1_H;                 //1ŴԴ
  Delay();                   //ӳ٣ȴȶ
  SensorData[0]=SEN1_IN;     //1Ŵ
  PSEN1_L ;                 //ر1ŴԴ
  
  PSEN2_H ;                 //2ŴԴ
  Delay();                   //ӳ٣ȴȶ
  SensorData[1]=SEN2_IN;     //2Ŵ
  PSEN2_L ;                 //ر2ŴԴ
  
  PSEN3_H ;
  Delay();
  SensorData[2]=SEN3_IN;  
  PSEN3_L ;
  
  PSEN4_H ;
  Delay();
  SensorData[3]=SEN4_IN;   
  PSEN4_L ;
  //ȡ4״̬SensorData[4]
  
  
  for(i=0;i<4;i++)           //صݣ0ʾߣΪ0ݱʾ
  {                           //Ϊʾ㣬Ϊ0ͳͳ1
   if(SensorData[i]==0)SensorData[i]=0;
   else                SensorData[i]=1;  //߶Ӧ鵥Ԫ1ߴ0
   }
  Input=SensorData[0]*1+SensorData[1]*2+SensorData[2]*4+SensorData[3]*8;       
  Sample_Input[j]=Input;
  j++;
 }
 
 for(j=0;j<COMPARE_NUM;j++)
 {
    if(Sample_Input[0]==Sample_Input[j+1]) falg_equel++;     
    if(falg_equel==COMPARE_NUM-1) { falg_equel=0;  break;}
    else 
    goto Loop;
 }
 return(Input);
} 


void Up()
{
    x=x_last;
    y=y_last+step;
    Point_To_Point( x,y);
}
void Right()
{
    x=x_last+step;
    y=y_last;
    Point_To_Point( x,y);
}
void Down()
{
    x=x_last;
    y=y_last-step;
    Point_To_Point( x,y);
}
void Left()
{
    x=x_last-step;
    y=y_last;
    Point_To_Point( x,y);
}



void Oren_control(unsigned char Input) 
{ 
   char i,j,k;   
  switch(Input)
   {
     case(0x00):  //ѭֹͣ
      { //־λ
        Find_starting=0;
        flag=0;
        
        TA_IE_OFF; //ʱֹͣ        
        
        MTOR_A_OFF; //ص
        MTOR_B_OFF;
                
        DelayNms(20000);
        Display_Clear();
        Display_String("    ˶    \n", 0, 0, M_8X16, D_NOR);
        Display_String("ʱ:\n", 24, 16, M_8X16, D_NOR);
        Display_Number(Seconds, 64, 16, 3, M_8X16, D_NOR);
        Display_String("s\n", 92, 16, M_8X16, D_NOR);
        Display_String("˳...\n", 16, 32, M_8X16, D_INV);
        DelayNms(15000);
    
        Seconds=0;
        Find_mode=0; //˳ѭ 
        Display_Clear();     
        break;      
      }   
     case(0x05):            //ˮƽϵͬʱƫ
       {
          if(flag==up)
          {
            Up();break;
          }
          if(flag==down)
          {
            Down();break;
          }
       }
       break;
     case(0x0a):  
       {
          if(flag==right)
          {Right();break;}
          if(flag==left)
          {Left();break;}
       }
       break;
     case(0x0f):
       {
         switch(flag)
         {
           case(up):    Up();break;
           case(right): Right();break;
           case(down):  Down();break;
           case(left):  Left();break;
           default: break;
         }
       }
       break;
       case(0x06):              //1.4ƫ
       { 
         if(flag==up) {DelayNms(delay_time);Right();break;}         
         if(flag==left) {DelayNms(delay_time);Down();break;}
       }              
       case(0x0c):               //1.2ƫ
       { 
        if(flag==up) {DelayNms(delay_time);Left();break;}         
         if(flag==left) {DelayNms(delay_time);Down();break;}
       }  
       case(0x03):               //4.3ƫ
       { 
         if(flag==down) {DelayNms(delay_time);Right();break;}         
         if(flag==left) {DelayNms(delay_time);Up();break;}       
       }  
       case(0x09):               //2.3ƫ
       {  
         if(flag==down) {DelayNms(delay_time);Left();break;}         
         if(flag==right) {DelayNms(delay_time);Up();break;}
       }  
       
     case(0x0e):                //1ƫ                    
     {
       if(flag==right||flag==left)                 //ԭˮƽ
       {
         Down();
         break;
       }
       if(flag==down)                             //ԭ
       {
        Down();
        break;
       }
       if(flag==up)                               // ԭ
       { 
         for(i=0;i<m;i++)
         { DelayNms(delay_time);
           Up();                    // Ƿϵ
         /*  ReadSensor();
          if((SensorData[0]==1))
         {
          Up();                         //ǣ
          flag=up;
          break;
         }*/
         }
          ReadSensor();
          if((SensorData[0]==1))
         {
          Up();                         //ǣ
          flag=up;
          break;
         }
       if(SensorData[0]==0)
        {  for(;i>0;i--)
           { DelayNms(delay_time);
             Down();                 //񣬻ԭ
           } 
         
          for(j=0;j<n;j++)
           { DelayNms(delay_time);
             Right();                  //Ƿ           
            /* ReadSensor();
             if(SensorData[1]==1)
             {
              x=x_last+step;
              y=y_last-half;
              Point_To_Point( x,y);                //ǣ
              flag=right;
              break;
             }*/
            }
           ReadSensor();
             if(SensorData[1]==1)
             {
              x=x_last+step;
              y=y_last-half;
              Point_To_Point( x,y);                //ǣ
              flag=right;
              break;
             }
           if(SensorData[1]==0)
            {
              for(j=n;j>0;j--)
              { DelayNms(delay_time);
                Left();                 // 񣬻ԭ
              }
            
            for(j=0;j<n;j++)
            { DelayNms(delay_time);
              Left();                  //            
              /*ReadSensor();
              if(SensorData[3]==1)
              {
                 x=x_last-step;
                y=y_last-half;
                Point_To_Point( x,y);                 //ǣ
                flag=left;
                break;
              }*/
             }
             ReadSensor();
              if(SensorData[3]==1)
              {
                 x=x_last-step;
                y=y_last-half;
                Point_To_Point( x,y);                 //ǣ
                flag=left;
                break;
              }
             if(SensorData[3]==0)
            {
              for(;j>0;j--)
              { DelayNms(delay_time);
              Right();                // 񣬻ԭ
              }
              a++;
            }
            }
           
        }
        if(a>1)
        {
          a=0;
          for(k=0;k<Try;k++)
          { DelayNms(delay_time);
            Up();                      //          
            flag=up;
          }

        }
         break;
       }
     }
     
     case(0x0b):                      //3ƫ
     {
        if(flag==right||flag==left)                    //ԭˮƽ
       {
         Up();
         break;
       }
       if(flag==up)                               //ԭ
       {
          Up();
         break;
       }
       if(flag==down)                               // ԭ
       {
         for(i=0;i<m;i++)
         {DelayNms(delay_time);
         Down();                    // Ƿϵ
        /* ReadSensor();
         if(SensorData[2]==1)
         {
           Down();                         //ǣ        
          flag=down;
          break;
         }*/
         }
          ReadSensor();
         if(SensorData[2]==1)
         {
           Down();                         //ǣ        
          flag=down;
          break;
         }
         if(SensorData[2]==0)
         { 
           for(;i>0;i--)
           {DelayNms(delay_time);
            Up();                 //񣬻ԭ
           }
         
           for(j=0;j<n;j++)
           {DelayNms(delay_time);
             Right();                  //Ƿ                    
            /* ReadSensor();
            if(SensorData[1]==1)
            {
              x=x_last+step;
              y=y_last+half;
              Point_To_Point( x,y);                 //ǣ
              flag=right;       
              break;
            }*/
            }
            ReadSensor();
            if(SensorData[1]==1)
            {
              x=x_last+step;
              y=y_last+half;
              Point_To_Point( x,y);                 //ǣ
              flag=right;       
              break;
            }
            if(SensorData[1]==0)
            {
              for(;j>0;j--)
              {DelayNms(delay_time);
                Left();                 // 񣬻ԭ
              }                       
            for(j=0;j<n;j++)
            {DelayNms(delay_time);
               Left();                  //
            /*  ReadSensor();
              if(SensorData[3]==1)
              {
                x=x_last-step;
                y=y_last+half;
                Point_To_Point( x,y);                 //ǣ
                flag=left;
               }*/
             // b++;
              }
               ReadSensor();
              if(SensorData[3]==1)
              {
                x=x_last-step;
                y=y_last+half;
                Point_To_Point( x,y);                 //ǣ
                flag=left;
                break;
               }
              
              if(SensorData[3]==0)
              {
                 for(j=0;j<n;j++)
                 {DelayNms(delay_time);
                   Right();                                 //񣬻ԭ
                 }
                 b++;
               }
             // b++;
             }
            }
        if(b>1)
        {
          b=0;
          for(k=0;k<Try;k++)
          {DelayNms(delay_time);
            Down();                      //          
            flag=down;
          }
       
        }
         break;
            }  
              
      }
      
      
     //}  
      
      case(0x0d):                   //2ƫ
     {
        if(flag==up||flag==down)                    //ԭڴֱ
       {
         Left();
         break;
       }
       if(flag==left)                               //ԭ
       {
        Left();
        break;
       }
       if(flag==right)                               // ԭ
       {
         for(i=0;i<m;i++)
         {
          DelayNms(delay_time);
          Right();                    // Ƿϵ
          /*ReadSensor();
          if(SensorData[1]==1)
          {
          Right();                        //ǣ        
          flag=right;
          break;
          }*/
         }
          ReadSensor();
          if(SensorData[1]==1)
          {
          Right();                        //ǣ        
          flag=right;
          break;
          }
         if(SensorData[1]==0)
         { 
           //Delay();
           for(;i>0;i--)
           {DelayNms(delay_time);
           Left();                //񣬻ԭ
           }
         
          for(j=0;j<n;j++)
           {DelayNms(delay_time);
             Up();                  //Ƿ          
            /*ReadSensor();
            if(SensorData[0]==1)
            {
              x=x_last-half;
              y=y_last+step;
              Point_To_Point( x,y);                //ǣ
               flag=up;
              break;
            }*/
           }
             ReadSensor();
            if(SensorData[0]==1)
            {
              x=x_last-half;
              y=y_last+step;
              Point_To_Point( x,y);                //ǣ
               flag=up;
              break;
            }
           if(SensorData[0]==0)
            {
             // Delay();
              for(;j>0;j--)
              {DelayNms(delay_time);
               Down();                 // 񣬻ԭ    
              }
         
            for(j=0;j<n;j++)
            {DelayNms(delay_time);
              Down();                  //
            
             /* ReadSensor();
              if(SensorData[2]==1)
              {
               x=x_last-half;
                y=y_last-step;
                Point_To_Point( x,y);                 //ǣ
                flag=down;
                break;
              } */
           //   c++;
             }
             ReadSensor();
              if(SensorData[2]==1)
              {
               x=x_last-half;
                y=y_last-step;
                Point_To_Point( x,y);                 //ǣ
                flag=down;
                break;
              } 
              if(SensorData[2]==0)
              {
                for(;j>0;j--)
              {DelayNms(delay_time);
               Up();                 // 񣬻ԭ    
              }
              c++;
              }
            }           
         }
        if(c>1)
        {
          c=0;
          for(k=0;k<Try;k++)
          {DelayNms(delay_time);
            Right();                      //          
            flag=right;
          }
         // ReadSensor();
         // if(Input==0x00){Find_mode=0;}
        }
       break;
       }
    }
    case(0x07):                         //4ƫ
     {
        if(flag==up||flag==down)                    //ԭڴֱ
       {
         Right();
         break;
       }
       if(flag==right)                               //ԭ
       {
        Right();
        break;
       }
       if(flag==left)                               // ԭ
       {
         for(i=0;i<m;i++)
         {DelayNms(delay_time);
          Left();                    // Ƿϵ
          /*ReadSensor();
          if(SensorData[3]==1)
          {
          Left();                         //ǣ
          flag=left;
          break;
         }*/
         }
          ReadSensor();
          if(SensorData[3]==1)
          {
          Left();                         //ǣ
          flag=left;
          break;
         }
         if(SensorData[3]==0)
         {  
           for(;i>0;i--)
           {DelayNms(delay_time);
           Right();
           }
                  
           for(j=0;j<n;j++)
           {DelayNms(delay_time);
            Up();                  //Ƿ
            /*ReadSensor();
            if(SensorData[1]==1)
            {
              x=x_last+half;
              y=y_last+step;
              Point_To_Point( x,y);                //ǣ
              flag=up;
              break;
            }*/
          }
          ReadSensor();
            if(SensorData[1]==1)
            {
              x=x_last+half;
              y=y_last+step;
              Point_To_Point( x,y);                //ǣ
              flag=up;
              break;
            }
           if(SensorData[1]==0)
            {
              for(;j>0;j--)
              {DelayNms(delay_time);
             Down();                 // 񣬻ԭ
              }
            
         
            for(j=0;j<n;j++)
            {DelayNms(delay_time);
               Down();                  //
             /* ReadSensor();
              if(SensorData[2]==1)
              {
                 x=x_last+half;
                y=y_last-step;
                Point_To_Point( x,y);                 //ǣ
                flag=down;
                break;
              } */
             // d++;
              
             }
                ReadSensor();
              if(SensorData[2]==1)
              {
                 x=x_last+half;
                y=y_last-step;
                Point_To_Point( x,y);                 //ǣ
                flag=down;
                break;
              } 
              if(SensorData[2]==0)
            {
              for(;j>0;j--)
              {DelayNms(delay_time);
               Up();                 // 񣬻ԭ              
              }
              d++;
            }
            } 
           }
       if(d>1)
        {
          d=0;
          for(k=0;k<Try;k++)
          {DelayNms(delay_time);
            Left();                      //          
            flag=left;
          }
    
        }
         break; 
      }                
   } 
             
     case(0x01):  {Up();Point_To_Point( x,y);break;}      //ֺܿܳbug,ߵյ㴦ܿܵ˻
     case(0x02):  {Right();Point_To_Point( x,y);break;}
     case(0x04):  {Down();Point_To_Point( x,y);break;}
     case(0x08):  {Left();Point_To_Point( x,y);break;}
     default: break;
   }  
}

