

#include "Key.h"

// ӳٿ
#define KEYTIME_FAST            300      // ٶ
#define KEYTIME_SLOW            3600     // ٶ
#define KEYTIME_FIRST           4000     // һγٶ
#define KEYTIME_STEP            299
// ԶƳӳٿ
#define WAIT_IDAL_TIME          (20000)  
#define WAIT_PAUSE_TIME         (10000)
// ӳٿ
#define BEEP_CTL_BY_TIMER       ENABLE
#define BEEP_DELAY               (9)      // ӳ, λ:, 1=15ms
unsigned char Cnt_BeepDelay;
// 

unsigned long int WAIT_TIME = WAIT_IDAL_TIME;
unsigned int      KeyTime = KEYTIME_FIRST;

// msӳ
void Key_DelayNms(unsigned int Nms)
{
  unsigned int i;
  for(; Nms>0; Nms--)
  {
    for(i=0; i<129; i++) _NOP();  
  }
}

void Key_Ondo(void)
{
  // ڰȴдĳ
  // , ڴ

}

// TBжִеĳ
void Key_CheckOnTimerInterrupt(void)
{
  #if (BEEP_CTL_BY_TIMER == ENABLE)
  // 
  if (Cnt_BeepDelay != 0) Cnt_BeepDelay--;
  else BEEPER_OFF;
  #endif
}

void Key_Beep(void)
{
  BEEPER_ON;
  #if (BEEP_CTL_BY_TIMER == ENABLE)
  Cnt_BeepDelay = BEEP_DELAY;
  #else
  for(unsigned char i=0; i<BEEP_DELAY; i++) Key_DelayNms(15);   // ӳ, ൱1
  BEEPER_OFF;
  #endif
}

// ųʼ
void Key_Init(void)
{
  // ųʼ
  PIN_KEYIN_DIR &= ~ KEYIN;
  PIN_KEYIN_OUT = 0xff;
  // ʼ
  BEEPER_OFF;
  BEEPER_DOUT;
  // ʼ
  BACKLIGHT_ON;
  BACKLIGHT_DOUT;
  
}

// ǰֵ
unsigned char Key_Read(void)
{
  unsigned char TempKey;
  TempKey = PIN_KEYIN_IN & KEYIN;
  if (TempKey == KEYIN) {return (NOKEY);}     // ûа
  return ((~TempKey) & KEYIN);
}

// ǰֵ, ʶ
unsigned char Key_Scan(void)
{
  unsigned char LastKey;
  unsigned int PushTime = 0;
  unsigned char LongPressFlag = 0;
  
  if (Key_Read() == NOKEY) {KeyTime = KEYTIME_FIRST;  return NOKEY;}            // ûа,  NOKEY
  Key_DelayNms(20); // ʱ20mS, 
  if (Key_Read() == NOKEY) {return NOKEY;}                                      // ,  NOKEY
  
  LastKey = Key_Read();                                                         // Чֵ
  while(Key_Read() == LastKey)                                                  // ȴͷ
  {
    Key_DelayNms(1);
    Key_Ondo();                                                                 // д
    
    PushTime++;                                                                 // 㰴ʱ     
    if (PushTime >= KeyTime)                                                    // жǷΪ
    {
      if (KeyTime == KEYTIME_FIRST) KeyTime = KEYTIME_SLOW;                     // һγٶ
      if (KeyTime > KEYTIME_FAST)   KeyTime -= KEYTIME_STEP;                    // Ժ󲻶ϼӿ찴ٶ, ֱٶΪֹ
      LongPressFlag = 1;
      break;
    }
  }
  Key_Beep();
                                                                                // ͷ֮
  if (LongPressFlag == 1) return(LastKey | LONG_PRESS_FLAG);                    // , ֵ + ־
  if (KeyTime != KEYTIME_FIRST) {LastKey = 0;};                                 // һβ㳤ȵĳ
  KeyTime = KEYTIME_FIRST;
  WAIT_TIME = WAIT_IDAL_TIME;
  return(LastKey);                                                              // ̰, ضֵ̰      
}

// ȴһЧİ, ʶ
unsigned char Key_Get(void)
{
  unsigned char TempKey;
  unsigned long int Wait;
  Wait = 0;
  do
  {
    if (Wait != WAIT_TIME){Wait++;}else{WAIT_TIME = WAIT_PAUSE_TIME; TempKey = 0xaa; break;}
    TempKey = Key_Scan();
  }
  while(TempKey == KEYIN);
  return(TempKey);
}

long int Key_SetValue_pointunit(unsigned char FuncKey, long int Value, long int Min, long int Max, unsigned int Step)
{ 
  switch(FuncKey)
  {
    case KEY_ADD    : Value += 1;    break;
    case KEY_SUB    : Value -= 1;    break;
    case KEY_ADD_L  : Value += Step; break;
    case KEY_SUB_L  : Value -= Step; break;
    default         : break;
  }
  if(Value > Max)  Value = Min;
  if(Value < Min)  Value = Max;
  return (Value);
}
long int Key_SetValue(unsigned char FuncKey, long int Value, long int Min, long int Max, unsigned int Step)
{ 
  switch(FuncKey)
  {
    case KEY_ADD    : Value += 1;    break;
    case KEY_SUB    : Value -= 1;    break;
    case KEY_ADD_L  : Value += Step; break;
    case KEY_SUB_L  : Value -= Step; break;
    default         : break;
  }
  if(Value%3==0&&FuncKey == KEY_ADD) Value +=1;
  if(Value%3==0&&FuncKey == KEY_SUB) Value -=1;
  if(Value > Max)  Value = Min;
  if(Value < Min)  Value = Max;
  return (Value);
}
long int Key_SetValueY(unsigned char FuncKey, long int Value, long int Min, long int Max, unsigned int Step)
{ 
  switch(FuncKey)
  {
    case KEY_ADD    : Value += 3;    break;
    case KEY_SUB    : Value -= 3;    break;
    case KEY_ADD_L  : Value += Step; break;
    case KEY_SUB_L  : Value -= Step; break;
    default         : break;
  }
  if(Value > Max)  Value = Min;
  if(Value < Min)  Value = Max;
  return (Value);
}

long int Key_SetValueT(unsigned char FuncKey, long int Value, long int Min, long int Max, unsigned int Step)
{ 
  switch(FuncKey)
  {
    case KEY_ADD    : Value += 1;    break;
    case KEY_SUB    : Value -= 1;    break;
    case KEY_ADD_L  : Value += Step; break;
    case KEY_SUB_L  : Value -= Step; break;
    default         : break;
  }
  if(Value > Max)  Value = Min;
  if(Value < Min)  Value = Max;
  return (Value);
}
